<?php

#################################################################################
#    PHP-RESIDENCE
#    Copyright (C) 2001-2002 by Marco Maria Francesco De Santis (marcods@gmx.net)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#################################################################################


# Function ricorsiva per l'assegnazione dell'appartamento.
function liberasettimane ($idinizio,$idfine,$idprenotafisse,$anno,$fatto,$appartamento, $profondita, $app_richiesti, $nome_tab_prenota = "prenota") {
$tableprenota = $nome_tab_prenota . $anno . $profondita;
$tableperiodi = periodi . $anno;
$tablenometariffe = ntariffe . $anno;
$fatto = "NO";
$num_da_liberare = 1;

# La prima volta che si entra nella function si trovano le prenotazioni con appartamento
# fisso o gi iniziate mettendole in idprenotafisse.
if (!$idprenotafisse) {
$idappfissi = pg_exec("select idprenota from $tableprenota where assegnazioneapp = 'k' ");
$numidappfissi = pg_numrows($idappfissi);
for ($num = 0 ; $num < $numidappfissi ; $num = $num + 1) {
$risul = pg_result($idappfissi,$num,idprenota);
$idprenotafisse[$risul] = "SI";
} # fine for $num
$oggi = date("M d, Y");
$annocorrente = date("Y");
$idperiodocorrente = pg_exec("select idperiodi from $tableperiodi where datainizio <= '$oggi' and datafine >= '$oggi' ");
$numidperiodocorrente = pg_numrows($idperiodocorrente);
if ( $numidperiodocorrente == 1 ) {
$idperiodocorrente = pg_result($idperiodocorrente,0,idperiodi);
$idappfissi = pg_exec("select idprenota from $tableprenota where iddatainizio <= '$idperiodocorrente' ");
} # fine if ( $numidperiodocorrente == 1 )
else {
if ( $anno < $annocorrente ) {
$idappfissi = pg_exec("select idprenota from $tableprenota");
} # fine if ( $anno <= $annocorrente )
if ( $anno >= $annocorrente ) {
$idappfissi = pg_exec("select idprenota from $tableprenota where iddatainizio < '-1' ");
} # fine if ( $anno > $annocorrente )
} # fine else if ( $numidperiodocorrente == 1 )
$numidappfissi = pg_numrows($idappfissi);
for ($num = 0 ; $num < $numidappfissi ; $num = $num + 1) {
$risul = pg_result($idappfissi,$num,idprenota);
$idprenotafisse[$risul] = "SI";
} # fine for $num
} # fine if (!$idprenotafisse)

# cicli da ripetere per ogni appartamento fino a che $fatto = SI
$idapp = pg_exec("select * from appartamenti order by priorita");
$numappartamenti = pg_numrows($idapp);
$fatto = "NO";

# primo ciclo che controlla se c' gi un appartamento libero
for ($num1 = 0 ; $num1 < $numappartamenti ; $num1 = $num1 + 1) {
$numapp = pg_result($idapp,$num1,idappartamenti);
if (!$app_richiesti or $app_richiesti[$numapp] == "SI") {
$prenotainperiodo = pg_exec("select * from $tableprenota where idappartamenti = '$numapp' and iddatainizio <= '$idfine' and iddatafine >= '$idinizio' ");
$numprenotainperiodo = pg_numrows($prenotainperiodo);
if ($numprenotainperiodo == 0) {
$appartamento = $numapp;
$fatto = "SI";
break;
} # fine if ($numprenotainperiodo == 0)
} # fine if (!$app_richiesti or $app_richiesti[$numapp] == "SI")
} # fine for $num1

if ($fatto != "SI") {

# ciclo che prova a spostare le prime prenotazioni ed eventualmente le
# mette in $da_liberare o $da_scambiare
for ($num1 = 0 ; $num1 < $numappartamenti ; $num1 = $num1 + 1) {
$numapp = pg_result($idapp,$num1,idappartamenti);
if (!$app_richiesti or $app_richiesti[$numapp] == "SI") {
$prenotainperiodo = pg_exec("select * from $tableprenota where idappartamenti = '$numapp' and iddatainizio <= '$idfine' and iddatafine >= '$idinizio' ");
$idiniziop = "";
$idfinep = "";
$mobile = "SI";
$numprenotainperiodo = pg_numrows($prenotainperiodo);

# Trovo le prenotazioni del periodo per l'appartamento $numapp, controllo
# che si posssano muovere e trovo le settimane iniziale e finale, e i 
# vincoli sull'appartamento di destinazione ($num_min_persome, $numcasa e
# $num_piano).
for ($num2 = 0 ; $num2 < $numprenotainperiodo ; $num2 = $num2 + 1) {
$idprenotainperiodo = pg_result($prenotainperiodo,$num2,idprenota);
$app_assegnabili[$idprenotainperiodo][esiste] = pg_result($prenotainperiodo,$num2,app_assegnabili);
if ($app_assegnabili[$idprenotainperiodo][esiste]) {
$vett_assegnabili = explode (",", $app_assegnabili[$idprenotainperiodo][esiste]);
$num_assegnabili = count($vett_assegnabili);
for ($num3 = 0 ; $num3 < $num_assegnabili ; $num3 = $num3 + 1) {
$app_ = $vett_assegnabili[$num3];
$app_assegnabili[$idprenotainperiodo][$app_] = "SI";
} # fine for $num3
} # fine if ($app_assegnabili[$idprenotainperiodo][esiste])
$num_persone[$idprenotainperiodo] = pg_result($prenotainperiodo,$num2,num_persone);
if ($idprenotafisse[$idprenotainperiodo] != "SI") {
$idinizioprenota[$idprenotainperiodo] = pg_result($prenotainperiodo,$num2,iddatainizio);
if (!$idiniziop or $idiniziop > $idinizioprenota[$idprenotainperiodo]) {
$idiniziop = $idinizioprenota[$idprenotainperiodo];
} # fine if (!$idiniziop or $idiniziop > $idinizioprenota)
$idfineprenota[$idprenotainperiodo] = pg_result($prenotainperiodo,$num2,iddatafine);
if (!$idfinep or $idfinep < $idfineprenota[$idprenotainperiodo]) {
$idfinep = $idfineprenota[$idprenotainperiodo];
} # fine if (!$idfinep or $idfinep > $idfineprenota)
} # fine if ($idprenotafisse[$idprenotainperiodo] != "SI")
else {
$mobile = "NO";
} # fine else if ($idprenotafisse[$idprenotainperiodo] != "SI")
} # fine for $num2


if ($mobile == "SI") {
# Provo a spostare le prenotazioni dell'appartamento $numapp.
$applica_spostamenti = "";
$applica_spostamenti2 = "";
$non_tutti_liberabili = "";
$mobile2 = "SI";
#$liberabile = "";
#$scambiabile = "";
#$da_scambiare = "";
for ($num2 = 0 ; $num2 < $numprenotainperiodo ; $num2 = $num2 + 1) {
$idprenotainperiodo = pg_result($prenotainperiodo,$num2,idprenota);
for ($num3 = 0 ; $num3 < $numappartamenti ; $num3 = $num3 + 1) {
if ($num3 != $num1) {
$numapp2 = pg_result($idapp,$num3,idappartamenti);
$num_persone2 = pg_result($idapp,$num3,maxoccupanti);
$prenotainperiodo2 = pg_exec("select * from $tableprenota where idappartamenti = '$numapp2' and iddatainizio <= '$idfineprenota[$idprenotainperiodo]' and iddatafine >= '$idinizioprenota[$idprenotainperiodo]' ");
$numprenotainperiodo2 = pg_numrows($prenotainperiodo2);
if ($app_assegnabili[$idprenotainperiodo][esiste] == "" or $app_assegnabili[$idprenotainperiodo][$numapp2] == "SI") {
if ($num_persone[$idprenotainperiodo] == "" or $num_persone[$idprenotainperiodo] <= $num_persone2) {
if ($numprenotainperiodo2 == 0) {
$nuovo_app[$idprenotainperiodo] = $numapp2;
$liberabile[$idprenotainperiodo] = "SI";
$scambiabile[$idprenotainperiodo] = "NO";
break;
} # fine if ($numprenotainperiodo2 == 0)
else {
# Se non si possono spostare vedere se sono da scambiare
$prenota_fissa_presente = "NO";
for ($num4 = 0 ; $num4 < $numprenotainperiodo2 ; $num4++) {
$idprenotainperiodo2 = pg_result($prenotainperiodo2,$num4,idprenota);
if ($idprenotafisse[$idprenotainperiodo2] == "SI") $prenota_fissa_presente = "SI";
} # fine for $num4
if ($prenota_fissa_presente == "NO") {
$scambiabile[$idprenotainperiodo] = "SI";
$da_scambiare[$idprenotainperiodo][$numapp2] = "SI";
} # fine if ($prenota_fissa_presente == "NO")
} # fine else if ($numprenotainperiodo2 == 0)
} # fine if ($num_persone[$idprenotainperiodo] == "" or $num_persone[$idprenotainperiodo] <= $num_persone2)
} # fine if ($app_assegnabili[$idprenotainperiodo][esiste] == "" or ...
} # fine if ($num3 != $num1)
} # fine for $num3

if ($liberabile[$idprenotainperiodo] != "SI") $tutti_liberabili = "NO";
if ($liberabile[$idprenotainperiodo] != "SI" and $scambiabile[$idprenotainperiodo] != "SI") $mobile2 = "NO";
} # fine for $num2

# Applico gli eventuali spostamenti, altrimenti metto i dati in $da_liberare
if ($tutti_liberabili != "NO") {
for ($num2 = 0 ; $num2 < $numprenotainperiodo ; $num2 = $num2 + 1) {
$idprenotainperiodo = pg_result($prenotainperiodo,$num2,idprenota);
$n_app = $nuovo_app[$idprenotainperiodo];
pg_exec("update $tableprenota set idappartamenti = '$n_app' where idprenota = '$idprenotainperiodo'");
} # fine for $num2
$appartamento = $numapp;
$fatto = "SI";
break;
} # fine if ($tutti_liberabili != "NO")

if ($mobile2 == "SI") {
$idinizio_da_liberare[$num_da_liberare] = $idiniziop;
$idfine_da_liberare[$num_da_liberare] = $idfinep;
$app_da_liberare[$num_da_liberare] = $numapp;
$num_da_liberare = $num_da_liberare + 1;
} # fine if ($mobile2 == "SI")

if ($fatto == "SI") { break; }
} # fine if ($mobile == "SI")
} # fine if (!$app_richiesti or $app_richiesti[$numapp] == "SI")
} # fine for $num1

} # fine if ($fatto != "SI")



# Se non  ancora $fatto chiamo ricorsivamente liberasettimane con i dati
# in $da_liberare e $da_scambiare, operando su una tabella temporanea.
if ($fatto == "NO") {
$nuova_profondita = $profondita + 1;
$nuova_tableprenota = $nome_tab_prenota . $anno . $nuova_profondita;
$tot_prenota = pg_exec("select idprenota from $tableprenota order by idprenota");
$num_tot_prenota = pg_numrows($tot_prenota);
$num_tot_prenota = $num_tot_prenota - 1;
$num_tot_prenota = pg_result($tot_prenota,$num_tot_prenota,idprenota);
include ("includes/crea_nuova_tableprenota.php");

for ($num1 = 1 ; $num1 < $num_da_liberare ; $num1 = $num1 + 1) {
$idprenotafisse2 = $idprenotafisse;
$new_num_tot_prenota = $num_tot_prenota;
$idiniziop = $idinizio_da_liberare[$num1];
$idfinep = $idfine_da_liberare[$num1];
$numapp = $app_da_liberare[$num1];
pg_exec("delete from $nuova_tableprenota");
pg_exec("insert into $nuova_tableprenota select idprenota,idappartamenti,iddatainizio,iddatafine,assegnazioneapp,app_assegnabili,num_persone,idprenota_compagna from $tableprenota");
$prenotainperiodo = pg_exec("select * from $nuova_tableprenota where idappartamenti = '$numapp' and iddatainizio <= '$idfinep' and iddatafine >= '$idiniziop' ");
$numprenotainperiodo = pg_numrows($prenotainperiodo);

# Muovo le prenotazioni liberabili
for ($num2 = 0 ; $num2 < $numprenotainperiodo ; $num2 = $num2 + 1) {
$idprenotainperiodo = pg_result($prenotainperiodo,$num2,idprenota);
if ($liberabile[$idprenotainperiodo] == "SI") {
$n_app = $nuovo_app[$idprenotainperiodo];
pg_exec("update $nuova_tableprenota set idappartamenti = '$n_app' where idprenota = $idprenotainperiodo");
} # fine if ($liberabile[$idpenotainperiodo] == "SI")
} # fine for $num2

# Riempio gli spazi vuoti con prenotazioni kostanti.
$idinizio_prenota_falsa = $idinizio;
$prenota_falsa_da_inserire = "NO";
for ($num2 = $idinizio ; $num2 <= ($idfine+1) ; $num2 = $num2 + 1) {
$prenota_presente = pg_exec("select idprenota from $nuova_tableprenota where idappartamenti = '$numapp' and iddatainizio <= '$num2' and iddatafine >= '$num2' ");
$num_prenota_presente = pg_numrows($prenota_presente);
if ($num_prenota_presente != 0 or $num2 == ($idfine+1)) {
if ($prenota_falsa_da_inserire == "SI") {
$new_num_tot_prenota = $new_num_tot_prenota + 1;
pg_exec("insert into $nuova_tableprenota (idprenota,idappartamenti,assegnazioneapp,iddatainizio,iddatafine) values ($new_num_tot_prenota,'$numapp','k',$idinizio_prenota_falsa,$idfine_prenota_falsa) ");
} # fine if ($prenota_falsa_da_inserire == "SI")
$prenota_falsa_da_inserire = "NO";
$idinizio_prenota_falsa = $num2 + 1;
} # fine if ($num_prenota_presente != 0 or $num2 == ($idfine+1))
else {
$prenota_falsa_da_inserire = "SI";
$idfine_prenota_falsa = $num2;
} # fine else if ($num_prenota_presente != 0 or $num2 == ($idfine+1))
} # fine for $num2

$fatto3 = "SI";
#chiamo ricorsivamente liberasettimane con gli app. $da_scambiare
for ($num2 = 0 ; $num2 < $numprenotainperiodo ; $num2 = $num2 + 1) {
$idprenotainperiodo = pg_result($prenotainperiodo,$num2,idprenota);
if ($scambiabile[$idprenotainperiodo] == "SI") {
$idinizioprenota2 = $idinizioprenota[$idprenotainperiodo];
$idfineprenota2 = $idfineprenota[$idprenotainperiodo];
if ($idinizioprenota2 > $idinizio) { $idinizio_rimpicciolito = $idinizioprenota2; }
else { $idinizio_rimpicciolito = $idinizio; }
if ($idfineprenota2 < $idfine) { $idfine_rimpicciolito = $idfineprenota2; }
else { $idfine_rimpicciolito = $idfine; }
pg_exec("update $nuova_tableprenota set iddatainizio = $idinizio_rimpicciolito, iddatafine = $idfine_rimpicciolito where idprenota = $idprenotainperiodo");
$idprenotafisse2[$idprenotainperiodo] = "SI";
$ap_ric = "";
$appartamento2 = "";
$fatto2 = "";
for ($num3 = 0 ; $num3 < $numappartamenti ; $num3 = $num3 + 1) {
$numapp2 = pg_result($idapp,$num3,idappartamenti);
if ($da_scambiare[$idprenotainperiodo][$numapp2] == "SI") { $ap_ric[$numapp2] = "SI"; }
} # fine for $num3
liberasettimane ($idinizioprenota2,$idfineprenota2,$idprenotafisse2,$anno,&$fatto2,&$appartamento2,$nuova_profondita,$ap_ric,$nome_tab_prenota);
pg_exec("update $nuova_tableprenota set iddatainizio = $idinizioprenota2, iddatafine = $idfineprenota2 where idprenota = $idprenotainperiodo");
$idprenotafisse2[$idprenotainperiodo] = "";
if ($fatto2 == "SI") {
pg_exec("update $nuova_tableprenota set idappartamenti = '$appartamento2' where idprenota = $idprenotainperiodo");
$new_num_tot_prenota = $new_num_tot_prenota + 1;
pg_exec("insert into $nuova_tableprenota (idprenota,idappartamenti,assegnazioneapp,iddatainizio,iddatafine) values ($new_num_tot_prenota,'$numapp','k',$idinizio_rimpicciolito,$idfine_rimpicciolito) ");
$idprenotafisse2[$new_num_tot_prenota] = "SI";
} # fine if ($fatto2 == "SI")
else {
$fatto3 = "NO";
break;
} # fine else if ($fatto2 == "SI")
} # fine if ($scambiabile[$idprenotainperiodo] == "SI")
} # fine for $num2

if ($fatto3 == "SI") {
$idprenota_cambiate = pg_exec("select $nuova_tableprenota.idprenota,$nuova_tableprenota.idappartamenti from $tableprenota,$nuova_tableprenota where $tableprenota.idprenota = $nuova_tableprenota.idprenota and $tableprenota.idappartamenti != $nuova_tableprenota.idappartamenti");
$num_cambiate = pg_numrows($idprenota_cambiate);
for ($num2 = 0 ; $num2 < $num_cambiate ; $num2 = $num2 + 1) {
$idprenota_cambiata = pg_result($idprenota_cambiate,$num2,idprenota);
$app_cambiato = pg_result($idprenota_cambiate,$num2,idappartamenti);
pg_exec("update $tableprenota set idappartamenti = '$app_cambiato' where idprenota = $idprenota_cambiata");
} # fine for $num2
$fatto = "SI";
$appartamento = $numapp;
break;
} # fine if ($fatto3 == "SI")
} # fine for $num1

pg_exec("drop table $nuova_tableprenota");
} # fine if ($fatto == "NO")

} # fine function liberasettimane




?>
